#################################################
#Patchfile for KUBE				#
#################################################

#################################################
#FILES						#
#################################################

%ext ck4
#Text plane starts at $2EE70 2EE70
%maphead maphead.ck4
%egahead EGAHEAD.CK4				#New graphics
%patchfile $20DF0 AUDIOHED.CK4			#Patch the Audiohead [652bytes]
%patchfile $249C2 Keen4.tli			#New tile properties


#7A20W: Items left to get
#7A22W  Inefficiency count
#7A24W: Total plats count
#7A26W: Death count
#7A28:  Bonus variable
#7A5CW: Can bomb
#7A58W: Number of platforms remaining
#7A5EW: Current level (Inc at level end)


#################################
#Ending sequence		#
#################################

#END cheat- set to maxlevel and finish level
%patch $9122 $83 $3E $C66BW  $00 $90 $90 $83 $3E $C6A9W  $00 $90 $90 $83 $3E
             $C687W  $00 $74 $0C $C7 $06 $7A5EW  $000AW  $C7 $06 $7A70W  $0002W

#Ending sequence doesn't wait for keypresses
%patch $9D03 $EB $66

#Don't show all border images
%patch $9612 $EB $63

#Help screen colors: Visible by default)
%patch $95FB $0000W

#Screen color change values (Unseen by default)
%patch $9A72 $0000W
%patch $9A87 $0000W
%patch $9AB7 $0000W
%patch $9B29 $0000W
%patch $9B5B $0000W
%patch $9B88 $0000W
%patch $9C85 $0000W
%patch $9DAB $0000W


#################################
#Game				#
#################################

#Remove compression
%patch $12D2C $55 $8B $EC $56 $57 $8C $DA $C4 $7E $0A $C5 $76 $06 $8B $4E $0E $D1
              $E9 $FC $F3 $A5 $73 $01 $A4 $8E $DA $5F $5E  $5D $CB

#Skip initialization screen (Frees $19AAA-$19FE9)
%patch $38AD $90 $90 $90 $90 $90 #Don't load B800
%patch $38D0 $90 $90 $90 $90 $90 #Don't display game info, 'Loading...' text
%patch $39B2 $90 $90 $90 $90 $90 #Don't wait for key, show 'Ready' text

#Disable single demos -Keen 4
%patch $3C32 $90 $90 $90 $90 $90 #Demo 1
%patch $3C47 $90 $90 $90 $90 $90 #Demo 2
%patch $3C5C $90 $90 $90 $90 $90 #Demo 3
%patch $3C6C $90 $90 $90 $90 $90 #Demo 4

#Pressing any key in the story screen doesn't go to main menu
%patch $5894 $90 $90 $90 $90

#Remove Story screen from demo loop
%patch $3CBD $04D1W

#How long to wait after text has scrolled in story screen -Keen 4
%patch $5778 $0020W

#Story text file
%patchfile $1EE40 "STORY.CK4"

#Disable help
%patch $3F09  $EB     #Unknown, initiation screen?
%patch $51AB  $EB     #During terminator text
%patch $7930  $EB     #In game levels
%patch $1CED9 $90 $90 #In Main Menu

#Disable status window
%patch $78B2 $EB $30

#Always use WoW scrolling
%patch $905B $EB

#Don't show Members saved in High Scores
%patch $5A44 $90 $90 $90 $90 $90

#Horizontal position of score name
%patch $5A1F $0038W

#Disable level entry window
%patch $62AD $CB

#Default score names and scores
%patch $33234 "CREDITS          " $00
%patch $33274 "                 " $00
%patch $332B4 "Lass: Mod        " $00
%patch $332F4 "Fleex: Abiathar  " $00
%patch $33334 "S.Bunny: Music   " $00
%patch $33374 "Lemm: Title      " $00
%patch $333B4 "ID: Original game" $00
%patch $333F4 "You: Player      " $00

#Default scores (Multiples of 500K)
%patch $3326E $0081B320L
%patch $332AE $007A1200L
%patch $332EE $007270E0L
%patch $3332E $006ACFC0L
%patch $3336E $00632EA0L
%patch $333AE $005B8D80L
%patch $333EE $0053EC60L
%patch $3342E $004C4B40L


#################################
#Music				#
#################################

# Number of entries in the music mapping table
%patch $8CA4 $18
# The music mapping table
%patch $2F206 $0001W
              $0005W
              $0002W
              $0003W
              $0000W
              $0007W
              $0004W
              $0006W
              $0004W
              $0000W
              $0008W
              $0000W
              $0000W
              $0000W
              $0000W
              $0000W
              $0000W
              $0000W
              $0000W
              $0003W
# Updated boundary between digitized sounds and IMF songs
%patch $8CEF $0099W
# Number of IMF songs
%patch $8C91 $09
# Updated pointers to the start of the song chunks
%patch $8C75 $C88FW
%patch $8C83 $C88FW
%patch $8D83 $C88FW


#################################
#Cheats				#
#################################

#Disable unwanted cheats
%patch $7467 $EB $35 #Disable Keen 4 F10-D (Frees 53 bytes at $7469)

#BAT cheat (Now F10 cheat) flips cheat mode variable
%patch $7830 $55 $8B $EC $56 $B8 $0003W  $50 $B8 $0010W  $50 $9A $19311070RL 
         $83 $C4 $04 $83 $3E $7A16W  $00 $75 $05 $B8 $05C5W  $EB $03 $B8 $05D3W
                 $50 $9A $19310E1FRL     $83 $C4 $02 $9A $1D060A9BRL     $9A
             $14600EDFRL     $9A $16540D59RL     $83 $36 $7A16W  $01 $5E $5D $CB

#Keys (F10)
%patch $7A9B $C6CFW  $00 $75 $0E $EB $10

#Text
%patch $2F435 "Cheat mode ON" $00
%patch $2F443 "Cheat mode OFF" $00

#Remove F10 press for cheats after mode activated
%patch $7ABE $90 $90

#Jump cheat is a pause button (Removes survival bonus)
%patch $7581 $83 $3E $C679W  $00 $74 $4E $FF $06 $7A26W  $9A $1D060999RL
                 $B8 $0004W  $50 $B8 $0011W  $50 $9A $19311070RL     $83 $C4
             $04 $B8 $052DW  $50 $9A $19310E1FRL     $83
             $C4 $02 $9A $1D060A9BRL     $9A $14600EDFRL     $B8 $0001W  $5F
             $5E $8B $E5 $5D $CB

#Text
%patch $2F39D "GAME PAUSED" $00

#Slowness of slow mode- make this a playable option
%patch $90B6 $0003W

#Slow motion removes both survival and cube bonuses
%patch $7690 $90 $FF $06 $7A26W  $FF $06 $7A58W  $83 $3E $C62DW  $00 $74 $05
             $B8 $0569W  $EB $03 $B8 $0578W

#Text
%patch $2F3D9 "Slow mode" $00
%patch $2F3E8 "Normal mode" $00

#God cheat rearranged to remove survival, cube bonus
%patch $74E1 $90 $FF $06 $7A26W  $FF $06 $7A58W  $83 $3E $C629W  $00 $74 $05
             $B8 $0508W  $EB $03 $B8 $0515W

#No clipping cheat rearranged to remove efficiency, survival bonus
%patch $760F $0E $8B $1E $D6 $A7 $C7 $47 $06 $0000W  $B8 $054AW  $EB $0C $8B
             $1E $D6 $A7 $C7 $47 $06 $0001W  $B8 $0559W
%patch $7633 $90 $FF $06 $7A26W  $FF $06 $7A22W

#Item cheat resets bomb variable
%patch $751A $83 $3E $C675W  $00 $74 $60 $9A $1D060999RL     $C7 $06 $7A5CW  $0000W
                 $B8 $0003W  $50 $B8 $0012W  $50 $9A $19311070RL     $83 $C4
             $04 $B8 $0521W  $50 $9A $19310E1FRL     $83 $C4 $02 
             $C4 $02 $9A $1D060A9BRL     $9A $14600EDFRL     $B8 $0001W  $5F
             $5E $8B $E5 $5D $CB

#Text
%patch $2F391 "Free bomb!" $00

#F10-W can't go past 9
%patch $77E4 $09
%patch $2F418 " Warp to which level(1-9):" $00


#################################
#Death window			#
#################################

#No level names in window or options
%patch $663A $EB $1B
%patch $66B2 $EB $27

#Move text in window up
%patch $66A5 $00
%patch $66C5 $00
%patch $66EB $02

#Rectangle 4 pixels above text option
%patch $66F0 $04

#Blank window bar bottom option
%patch $2F16F $0A $00

#Rectangle doesn't move
%patch $670B $EB $04 #From bottom option

#Esc retries level
%patch $6935 $EB $04

#Remove 'Try again'; reset cube counter on death
%patch $66DB $C7 $06 $7A58W $0000W $EB $04

#Only one option in window
%patch $6989 $E9 $FD7FW

#Change default option in window to 'Exit'
%patch $6709 $0001W

#Either selected option retries level
%patch $6971 $5F $5E $8B $E5 $5D $CB

#Death message
%patch $66F6  $0301W
%patch $2F171 "You have failed!" $0A $0A
              "Press any key to" $0A
              "try again!" $00

#Change flasher size to enclose new message
%patch $6776 $002EW #Bottom
%patch $6797 $002FW #Bottommost
%patch $67BF $002DW #Side 1
%patch $67D9 $002DW #Side 2
%patch $67F7 $002DW #Side 3
%patch $6815 $002DW #Side 4

#Rectangle left boundary -1 pixel lefter
%patch $6748 $0003W #Topmost
%patch $6767 $0003W #Top
%patch $6788 $0003W #Bottom
%patch $67A9 $0003W #Bottommost
%patch $67B9 $0003W #Side 1
%patch $67D3 $0004W #Side 2
%patch $683D $0003W #Topmost blanking
%patch $685F $0003W #Top blanking
%patch $6883 $0003W #Bottom blanking
%patch $68A7 $0003W #Bottommost blanking
%patch $68BA $0003W #Side 1 blanking
%patch $68D7 $0004W #Side 2 blanking

#Any key restarts level
%patch $6967 $00 $75

#Store Keen's score on level load, set item and cube vars to 0
%patch $69E8 $A1 $7A50W  $A3 $7A4CW  $A1 $7A52W  $A3 $7A4EW $EB $3D

#Reset Keen's score on death (Overwrite blanking code!)
%patch $6829 $A1 $7A4CW  $A3 $7A50W  $A1 $7A4EW  $A3 $7A52W $EB $11


#################################
#Game menus			#
#################################

#Shrink number of main menu options
%patch $1FD80 $0003W $0000W $0031W $48BFW $0000W $1F930048RL $0000W $0000W #New game (Call New game menu)
%patch $1FD92 $0003W $0000W $002EW $48DCW $0000W $1FCC0090RL $0000W $0000W #Configure (Call configure menu)
%patch $1FDA4 $0001W $0000W $0013W $48E6W $0001W $00000000L  $0000W $0000W #Return (Demo or game)
%patch $1FDB6 $0003W $0000W $0019W $48EFW $0000W $1FCC00A6RL $0000W $0000W #Paddle war (Call Paddle menu)
%patch $1FDC8 $0001W $0000W $0010W $48FAW $0003W $00000000L  $0000W $0000W #Quit
%patch $1FDDA $0000W $0000W $0000W $0000W $0000W $00000000L  $0000W $0000W #Limiter

#Remove game sensitive menu options
%patch $1CC95 $90 $90 $90 $90

#Text
%patch $33756 "RETURN" $00

#Adjust main menu placement
%patch $1FE22 $0020W $0010W

#Eliminate Gravis menu option, options menu options
%patch $1FCE4 $0003W $0008W $0025W $4891W $0000W $1FC30036RL $0000W $0000W #Keyboard (Call keyboard menu)
%patch $1FCF6 $0003W $0000W $0002W $489EW $0000W $1FC3004CRL $0000W $0000W #Joystick 1 (Call Joy 1 menu)
%patch $1FD08 $0003W $0000W $0003W $48AEW $0000W $1FC30062RL $0000W $0000W #Joystick 2 (Call Joy 2 menu)
%patch $1FD1A $0000W $0000W $0000W $0000W $0000W $00000000L  $0000W $0000W #Eliminate Gravis

#Change configure buttons texts, locations
%patch $1FBD4 $0024W
%patch $1FBE6 $0024W $4864W
%patch $1FBF8 $0024W $4A04W
%patch $336CD "BOMB 1" $00
%patch $336D4 "BOMB 2" $00
%patch $33874 "BOMB 3" $00


#################################
#Score panel			#
#################################

#Move scorebox to screen bottom
%patch $DD8A $0B80W #Vertical location
%patch $DD91 $0000W #Horizontal location

#Lives counter location
%patch $DC94 $0004W #Vertical
%patch $DC9E $11    #Horizontal

#Ammo counter location
%patch $DBA2 $0004W #Vertical
%patch $DBAC $1A    #Horizontal


#################################
#UpKeen (Eliminated upsprite!)	#
#################################

#upKeen sequence, mostly animating falling down a hole =$0CD4W
%patch $2FB44 $0105W $0105W $0000W $0000W $0000W $000DW $0000W $0000W
              $00000000L    $00000000L    $09DC176ERL   $0D2EW
%patch $2FB9E $013DW $013DW $0000W $0000W $0000W $000DW $0000W $0000W
              $00000000L    $00000000L    $09DC176ERL   $0D4CW
%patch $2FBBC $0142W $0142W $0000W $0000W $0000W $000DW $0000W $0000W
              $00000000L    $00000000L    $09DC176ERL   $0D6AW
%patch $2FBDA $013EW $013EW $0000W $0000W $0000W $000DW $0000W $0000W
              $00000000L    $00000000L    $09DC176ERL   $0D88W
%patch $2FBF8 $013FW $013FW $0000W $0000W $0000W $000DW $0000W $0000W
              $00000000L    $00000000L    $09DC176ERL   $0DA6W
%patch $2FC16 $0140W $0140W $0000W $0000W $0000W $000DW $0000W $0000W
              $00000000L    $00000000L    $09DC176ERL   $0DC4W
%patch $2FC34 $0141W $0141W $0000W $0000W $0000W $000DW $0000W $0000W #Winlevel behavior
              $0FA80439RL   $00000000L    $09DC176ERL   $0E00W
%patch $2FC70 $FFFFW $FFFFW $0000W $0000W $0000W $009DW $0000W $0000W #Vanish
              $00000000L    $00000000L    $09DC176ERL   $0E00W

#Final upKeen sequence: Bonuses, uplevel =$0FA80439RL
%patch $FEB9 $55 $8B $EC $56 $57 $8B $76 $06 $8B $7E $08 $83 $3E $7A26W  $00 #Check survival, 75K +4
             $75 $16 $B8 $927CW  $50 $9A $06BD1EF2RL     $9A $06BD1EF2RL   
             $83 $C4 $02 $83 $06 $7A28W  $04 $83 $3E $7A58W  $00 $75 $15 $B8 #Check cubes, 100K, +1
             $C350W  $50 $9A $06BD1EF2RL     $9A $06BD1EF2RL     $83 $C4 $02
             $FF $06 $7A28W  $83 $3E $7A20W  $00 $75 $16 $B8 $927CW  $50 $9A #Check items, 75K +2
             $06BD1EF2RL     $9A $06BD1EF2RL     $83 $C4 $02 $83 $06 $7A28W  #Check effic, 100K +8
             $02 $A1 $7A24W  $3B $06 $7A22W  $72 $16 $B8 $C350W  $50 $9A
         $06BD1EF2RL     $9A $06BD1EF2RL     $83 $C4 $02 $83 $06 $7A28W  $08
             $83 $3E $7A28W  $0F $75 $11 $83 $06 $7A52W  $07 $B8 $A120W  $50 #If perfect, 500K
             $9A $06BD1EF2RL     $83 $C4 $02 $9A $0E8F0BA5RL     $C7 $06     #Bonus wndow
         $7A58W  $0000W  $C7 $06 $7A5CW  $0000W  
             $C7 $06 $7A70W  $0002W  $5F $5E $5D $CB

#Win level code; increment level by 1, if maxlev then win game
%patch $6B1E $90 $90 $90 $90 $B8 $000DW  $50 $9A $187409F1RL     $83 $C4 $02 #Winsound
             $A1 $7A5EW  $A3 $7A68W  $A1 $A7EDW  $A3 $A7C2W  $B8 $000AW  $50 #Load
             $33 $C0 $50 $B8 $7A20W  $50 $9A $00001D25RL     $83 $C4 $06 $83 #Clear variables
             $3E $7A5EW  $0A $72 $48 $EB $9C				     #Maxlevel is 10


#################################
#Win level messages		#
#################################

#Disable Council Member message window
%patch $F52E $90 $90 $90 $90 $90
%patch $F544 $90 $90 $90 $90 $90
%patch $F534 $0004W

#No pause before window goes
%patch $F5C8 $EB $0A

#Position of text from window top
%patch $F57D $04

#Increase window height
%patch $F54A $0009W

#Variable that selects bonus reply
%patch $F580 $7A28W

#Location of text pointer list
%patch $F586 $3EE5W

#Message list
%patch $32D55 $1ADCW #No bonus
              $1B96W #1
              $1BE1W #2
              $1B7DW #21
              $1CA9W #3
              $1C13W #31
              $1BC8W #32
              $1B64W #321
              $1D26W #4
              $1CC2W #41
              $1CF4W #42
              $1C45W #421
              $1C90W #43
              $1BFAW #431
              $1BAFW #432
              $1AE6W #4321 (5!)

#Bonus replies: 1st message group
%patch $3094C "NO BONUS!" $00

#Second message group: full bonus
%patch $30956 "Efficiency bonus: 100000" $0A		#4
              "Survival bonus:    75000" $0A		#3
              "Item bonus:        75000" $0A		#2
              "Cube bonus:       100000" $0A $0A	#1

              "PERFECT BONUS:    500000" $00

#Third message group: 321, 21, 1
%patch $309D4 "Survival bonus:    75000" $0A
              "Item bonus:        75000" $0A
              "Cube bonus:       100000" $00

#Fourth group: 432, 32, 2
%patch $30A1F "Efficiency bonus: 100000" $0A
              "Survival bonus:    75000" $0A
              "Item bonus:        75000" $00

#Fifth group: 431, 31
%patch $30A6A "Efficiency bonus: 100000" $0A
              "Survival bonus:    75000" $0A
              "Cube bonus:       100000" $00

#Sixth group: 421
%patch $30AB5 "Efficiency bonus: 100000" $0A
              "Item bonus:        75000" $0A
              "Cube bonus:       100000" $00

#Seventh group: 43, 3
%patch $30B00 "Efficiency bonus: 100000" $0A
              "Survival bonus:    75000" $00

#Eighth group: 41
%patch $30B32 "Efficiency bonus: 100000" $0A
              "Cube bonus:       100000" $00

#Ninth group: 42
%patch $30B64 "Efficiency bonus: 100000" $0A
              "Item bonus:        75000" $00

#Tenth group: 4
%patch $30B96 "Efficiency bonus: 100000" $00


#################################
#Cube nullifyier		#
#################################

#Lindsey sprite type (Type 3: Cube destroyer)
%patch $127E9 $03

#Lindsey's action sits and destroys
%patch $3275A $01E8W $01E8W $0002W $0000W $0000W $0000W $0000W $0000W
              $00000000L    $00000000L    $09DC176ERL   $38EAW

#Don't cache stuff
%patch $EA1E $E9 $03DCW

#Cube nullifyier can destroy cubes offscreen
%patch $127EE $0002W


#################################
#Screen bottom killer		#
#################################

#Spawn uses new action (Moved due to Platform patches!)
%patch $11941 $0DE2W

#Dropping Platform sprite type (Keen can't stand on it)
%patch $11910 $05

#Change droppable platform to sit and kill Keen =$0DE2W
%patch $2FC52 $00FDW $00FDW $0002W $0000W $0000W $0000W $0000W $0000W
              $00000000L    $0FA8041ARL   $09DC176ERL   $0DE2W

#Collision: Kill Keen even with Godmode =$0FA8041ARL
%patch $FE9A $55 $8B $EC $56 $57 $8B $76 $06 $8B $7E $08 $83 $3D $02 $75 $0B
             $C7 $06 $C629W  $0000W  $9A $0B8013E9RL     $5F $5E $5D $CB

#Three more, EMH exclusive
%patch $EEC9 $038EW #All diff killer (At $EC7E)
%patch $EECB $03A3W #Easy killer (At $EC93)
%patch $EECD $03ADW #Med killer (At $EC9D)
%patch $EECF $03B7W #Hard killer (At $ECA7)

#EMH initiators
%patch $EC93 $83 $3E $7A6CW  $01 $74 $E4 $E9 $0160W #Easy
%patch $EC9D $83 $3E $7A6CW  $02 $74 $DA $E9 $0156W #Medium
%patch $ECA7 $83 $3E $7A6CW  $03 $74 $D0 $E9 $014CW #Hard


#################################
#Non-map Keen stuff		#
#################################

#Change Keen's death animations to fit
%patch $2FB62 $0118W $0118W
%patch $2FB80 $0119W $0119W

#Platforms to destroy are 0 at game start
%patch $5CCD $7A58W $0000W

#If Keen dies change his death counter
%patch $CC10 $7A26W $0001W

#Never produce swimming dead Keen
%patch $CC2A $83 $3E $A7EDW  $11 $EB


#################################
#Map Keen stuff			#
#################################

#Increase map Keen's cache to cover ALL graphics:
%patch $306E4 $00D7W #Map Keen Cache start
%patch $3072E $0144W #Map Keen cache end

#Three different keen starts (Plus universal Keen!) -pointers
%patch $EE87 $006EW #Medium Keen (At $E95E)
%patch $EE8B $0078W #Hard Keen (At $E968)

#Inits (Check difficulty, proceed to mapk if equal.)
%patch $E954 $83 $3E $7A6CW  $01 $74 $51 $E9 $049FW #Easy
%patch $E95E $83 $3E $7A6CW  $02 $74 $47 $E9 $0495W #Medium
%patch $E968 $83 $3E $7A6CW  $03 $74 $3D $E9 $048BW #Hard

#Replace level entrance check code with bomb placement code, incs bombcount, can'tbomb, nuh-uh sound
%patch $DF1E $55 $8B $EC $56 $8B $76 $06 $83 $3E $7A5CW  $00 $75 $5D $B8 $0001W  $50 $9A $06BD1E11RL
             $83 $C4 $02 $8B $44 $0A $8B $1E $D8 $A7 $89 $47 $0A $8B $44 $0C
             $05 $0000W  $89 $47 $0C $C7 $47 $20 $0000W  $C7 $07 $0001W  $C7
             $47 $02 $0003W  $B8 $0029W  $50 $9A $187409F1RL     $83 $C4 $02
             $8B $44 $0E $8B $1E $D8 $A7 $89 $47 $0E $B8 $1738W  $50 $53 $9A
             $09DC118CRL     $83 $C4 $04 $C7 $06 $7A5CW  $0001W  $FF $06 $7A22W
                 $5E $5D $CB $83 $3E $788EW  $00 $75 $0C $B8 $000EW  $50 $9A #Only playsound if nosound
             $187409F1RL     $83 $C4 $02 $5E $5D $CB

#Keen can collect items on map
%patch $30370 $0B8014A9RL #Waiting
%patch $30424 $0B8014A9RL #Walking

#Keen always uses map-type tile interaction
%patch $8FBC $A7EDW $00 $EB

#Change tile collision to react to deadly tiles and exits
%patch $E1F1 $03 $75 $07 $9A $0B8013E9RL     $EB $1C $83 $FF $0B $75 $17 $81
             $7C $1C $14CEW  $72 $10 $B8 $0CD4W  $50 $FF $36 $D6 $A7 $9A
         $09DC120ARL     $83 $C4 $04 $5F $5E $8B $E5 $5D $CB

#Map Keen spawning code: Different in Level 19, simplified
%patch $DDFA $55 $8B $EC $8B $1E $D6 $A7 $C7 $07 $0002W  $8B $46 $06 $B1 $08
             $D3 $E0 $89 $47 $0A $8B $46 $08 $D3 $E0 $89 $47 $0C $8B $1E $D6
             $A7 $C7 $47 $02 $0002W  $C7 $47 $20 $0001W  $C7 $47 $0E $0000W
             $C7 $47 $10 $0000W  $C7 $47 $3E $0006W  $C7 $47 $40 $0003W  $C7
             $47 $42 $0000W  $C7 $47 $1E $0106W  $83 $3E $A7EDW  $13 $75 $0A
             $C7 $47 $1E $0144W  $B8 $14ECW  $EB $03 $B8 $14CEW  $50 $53 $9A
             $09DC118CRL     $83 $C4 $04 $5D $CB

#First map action: bring up Lindsey window, goto map2
%patch $3033E $0000W $0000W $0000W $0000W $0000W $0010W $0000W $0000W
              $0D8F0826RL   $00000000L    $09DC176ERL   $14ECW

#Swimming Map Keen's behavior (Level name window)
%patch $E116 $55 $8B $EC $56 $8B $76 $06 $9A $0E8F0645RL     $9A
             $16540D59RL     $5E $5D $CB

#No Keen's reply window
%patch $EFFA $E9 $00A1W

#Short pause before window vanishes
%patch $EFE5 $04

#Use level-specific texts
%patch $EFB2 $8B $1E $A7EDW  $D1 $E3 $FF $B7 $19DCW  $9A $19310EBDRL     $83
             $C4 $02 $EB $0D

#Don't display Lindsey's head in window, center text
%patch $EF4E $EB $05
%patch $EF83 $EB $12
%patch $EFA0 $00
%patch $EFA5 $00

#Reset bomb on Lindsey appear
%patch $EF4E $C7 $06 $7A5CW  $0000W  $90

#Lindsey's window
%patch $EF74 $0006W #Height
%patch $EF78 $0010W #Width

#Loading text
%patch $0EFA7 $1D3FW
%patch $30BAF "NOW SOLVING:" $0A $0A $00

#Level name list
%patch $3084C $1D4EW #Tutorial
              $1D57W #Grey
              $1D61W #Gaps
              $1D67W #Icy
              $1D6BW #Squared
              $1D73W #Kubed
              $1D79W #Hidden
              $1D80W #Warm
              $1D85W #Hot
              $1D89W #Check
              $1D95W #Horizontal

#Level names:
%patch $30BBE "Tutorial" $00
%patch $30BC7 "Greyscale" $00
%patch $30BD1 "Gaps?" $00
%patch $30BD7 "Icy" $00
%patch $30BDB "Squared" $00
%patch $30BE3 "Kubed" $00
%patch $30BE9 "Hidden" $00
%patch $30BF0 "Warm" $00
%patch $30BF5 "Hot" $00
%patch $30BF9 "Checkerboard" $00
%patch $30C05 "Horizontal" $00


#################################
#Bombs				#
#################################

#Bomb sequence: ticks down and boom
%patch $305A8 $00F1W $00F1W $0000W $0000W $0000W $001AW $0000W $0000W
              $0FA803DFRL   $00000000L    $09DC176ERL   $0CB6W
%patch $2FB26 $00F1W $00F1W $0003W $0000W $0000W $01B0W $0000W $0000W #This action on easy slows bombs
              $0FA803C9RL   $00000000L    $09DC176ERL   $0BC6W
%patch $2FA36 $0134W $0134W $0000W $0000W $0000W $001BW $0000W $0000W
              $0FA803DFRL   $00000000L    $09DC176ERL   $0BE4W
%patch $2FA54 $0135W $0135W $0000W $0000W $0000W $001AW $0000W $0000W
              $0FA803DFRL   $00000000L    $09DC176ERL   $0C02W
%patch $2FA72 $0136W $0136W $0000W $0000W $0000W $001BW $0000W $0000W
              $0FA803DFRL   $00000000L    $09DC176ERL   $0C20W
%patch $2FA90 $0137W $0137W $0000W $0000W $0000W $001AW $0000W $0000W
              $0FA803DFRL   $00000000L    $09DC176ERL   $0C3EW
%patch $2FAAE $0138W $0138W $0000W $0000W $0000W $001BW $0000W $0000W
              $0FA803DFRL   $00000000L    $09DC176ERL   $0C5CW
%patch $2FACC $0139W $0139W $0000W $0000W $0000W $001AW $0000W $0000W
              $0FA803DFRL   $00000000L    $09DC176ERL   $0C7AW
%patch $2FAEA $013AW $013AW $0000W $0000W $0000W $001BW $0000W $0000W
              $0FA803DFRL   $00000000L    $09DC176ERL   $0C98W
%patch $2FB08 $013BW $013BW $0000W $0000W $0000W $001BW $0000W $0000W #Detonate
              $0FA8033ARL   $00000000L    $09DC176ERL   $1756W

#Bomb tick behavior: Make ticking noise =$0FA803DFRL
%patch $FE5F $55 $8B $EC $56 $8B $76 $06 $8B $44 $0A $B8 $0030W  $50 $9A
         $187409F1RL     $83 $C4 $02 $5E $5D $CB

#Bomb UNdetonate behavior: play sound, reset bomb variable, change type =$0FA80269RL
%patch $FCE9 $55 $8B $EC $56 $8B $76 $06 $8B $44 $0A $B8 $0026W  $50 $9A
         $187409F1RL     $83 $C4 $02 $C7 $06 $7A5CW  $0000W  $C7 $04 $0001W
             $5E $5D $CB

#Easy slowdown action: If not easy, change action =$0FA803C9RL
%patch $FE49 $55 $8B $EC $56 $8B $76 $06 $83 $3E $7A6CW  $01
             $74 $05 $C7 $44 $1C $0BC6W  $5E $5D $CB

#Bomb detonate behavior: change type =$0FA8033ARL
%patch $FDBA $55 $8B $EC $56 $8B $76 $06 $8B $44 $0A $C7 $04 $0003W
             $5E $5D $CB

#Bomb detonation sequence
%patch $305C6 $011AW $011AW $0000W $0000W $0000W $0008W $0000W $0000W
              $00000000L    $09DC1752RL   $09DC176ERL   $1774W
%patch $305E4 $011BW $011BW $0000W $0000W $0000W $0008W $0000W $0000W #Reset type to harmless
              $0FA80269RL   $09DC1752RL   $09DC176ERL   $1792W
%patch $30602 $011CW $011CW $0000W $0000W $0000W $0008W $0000W $0000W
              $00000000L    $09DC1752RL   $09DC176ERL   $17B0W
%patch $30620 $011DW $011DW $0000W $0000W $0000W $0008W $0000W $0000W
              $00000000L    $09DC1752RL   $09DC176ERL   $17CEW
%patch $3063E $011EW $011EW $0000W $0000W $0000W $0008W $0000W $0000W
              $00000000L    $09DC1752RL   $09DC176ERL   $17ECW
%patch $3065C $011FW $011FW $0000W $0000W $0000W $0008W $0000W $0000W
              $00000000L    $09DC1752RL   $09DC176ERL   $0000W


#################################
#Platforms (Cubes)		#
#################################

#Increase platform cache to hold last anims
%patch $3074E $01EBW

#4 more kinds of platform (Black 2-5)
%patch $EEC1 $0372W
%patch $EEC3 $0372W
%patch $EEC5 $0372W
%patch $EEC7 $0372W

#Cube behavior - difficulty affects speed, if 0 plats rush offscreen with sound
%patch $11544 $55 $8B $EC $83 $EC $04 $56 $57 $8B $7E $06 $8B $45 $0E $BA $0000W
                  $F7 $EA $F7 $2E $4C $A5 $A3 $C923W  $83 $3E $7A6CW  $01 $74
              $38 $83 $3E $7A58W  $00 $74 $46 $83 $3E $7A6CW  $02 $74 $15 $8B
              $45 $10 $BA $0003W  $F7 $EA $F7 $2E $4C $A5 $A3 $C921W  $5F $5E
              $8B $E5 $5D $CB $8B $45 $10 $BA $0002W  $F7 $EA $F7 $2E $4C $A5
              $A3 $C921W  $5F $5E $8B $E5 $5D $CB $8B $45 $10 $BA $0001W  $F7
              $EA $F7 $2E $4C $A5 $A3 $C921W  $5F $5E $8B $E5 $5D $CB $8B $45
              $10 $BA $0030W  $F7 $EA $F7 $2E $4C $A5 $A3 $C921W  $B8 $0002W
              $50 $9A $187409F1RL     $83 $C4 $02 $5F $5E $8B $E5 $5D $CB

#Eight Plat types; count noblack-plats, no clipping
%patch $114AB $55 $8B $EC $33 $C0 $50 $9A $06BD1E11RL     $83 $C4 $02 $8B $1E
              $D8 $A7 $C7 $07 $0014W  $C7 $47 $02 $0002W  $C7 $47 $20 $0002W
              $8B $1E $D8 $A7 $C7 $47 $0E $00 $00 $C7 $47 $10 $01 $00 $C7 $47
              $06 $0000W  $8B $46 $06 $B1 $08 $D3 $E0 $89 $47 $0A $8B $46 $08
              $D3 $E0 $89 $47 $0C $8B $5E $0A $83 $FB $07 $77 $49 $D1 $E3 $2E #4 kinds of platform, $1153C
              $FF $A7 $0DD3W  $B8 $0E78W  $50 $EB $2C $B8 $0E5AW  $50 $EB $26 #BlackxX types
              $B8 $0E3CW  $50 $EB $20 $B8 $0E1EW  $50 $EB $1A $B8 $31C4W  $50
              $EB $10 $B8 $31A6W  $50 $EB $0A $B8 $316AW  $50 $EB $08 $B8
          $3188W  $50 $FF $06 $7A58W  $FF $36 $D8 $A7 $9A $09DC118CRL     $83 #Blacks doen't +1 (EB 08)
              $C4 $04 $FF $06 $7A24W  $5D $CB

#Platform direction list
%patch $115D3 $0D23W #Black platform
              $0D29W #White platform
              $0D1DW #Light grey platform
              $0D17W #Dark grey platform
              $0D11W #Black platform x2
              $0D0BW #Black platform x3
              $0D05W #Black platform x4
              $0CFFW #Black platform x5

#Remove Platform flames
%patch $11792 $E9 $013DW

#Four kinds of Platforms use different animations, collisions (Can't use base anim!)
%patch $31FDA $01E8W $01E8W $0002W $0000W $0000W $0000W $0000W $0000W #Black -$316AW
              $10800D44RL   $09DC1752RL   $09DC176ERL   $0000W
%patch $31FF8 $01E6W $01E6W $0002W $0000W $0000W $0000W $0000W $0000W #White -$3188W
              $10800D44RL   $0FA802B1RL   $09DC176ERL   $0000W
%patch $32016 $01E5W $01E5W $0002W $0000W $0000W $0000W $0000W $0000W #Light grey -$31A6W
              $10800D44RL   $0FA802D8RL   $09DC176ERL   $0000W
%patch $32034 $01E7W $01E7W $0002W $0000W $0000W $0000W $0000W $0000W #Dark grey -$31C4W
              $10800D44RL   $0FA802FFRL   $09DC176ERL   $0000W
%patch $2FC8E $01E9W $01E9W $0002W $0000W $0000W $0000W $0000W $0000W #Blackx2 -$0E1EW
              $10800D44RL   $09DC1752RL   $09DC176ERL   $0000W
%patch $2FCAC $01EAW $01EAW $0002W $0000W $0000W $0000W $0000W $0000W #Blackx3 -$0E3CW
              $10800D44RL   $09DC1752RL   $09DC176ERL   $0000W
%patch $2FCCA $01EBW $01EBW $0002W $0000W $0000W $0000W $0000W $0000W #Blackx4 -$0E5AW
              $10800D44RL   $09DC1752RL   $09DC176ERL   $0000W
%patch $2FCE8 $0143W $0143W $0002W $0000W $0000W $0000W $0000W $0000W #Blackx5 -$0E78W
              $10800D44RL   $09DC1752RL   $09DC176ERL   $0000W

#Platform deaths (All kill Keen, change to diff when shot) =$0FA802B1RL 500pts
%patch $FD31 $55 $8B $EC $56 $57 $8B $76 $06 $8B $7E $08 $83 $3D $03 $75 $6B
             $C7 $44 $1C $098CW  $B8 $0025W  $50 $9A $187409F1RL     $83 $C4
             $02 $B8 $01F4W  $50 $EB $4C

#Dark grey death =$0FA802D8RL 100pts
%patch $FD58 $55 $8B $EC $56 $57 $8B $76 $06 $8B $7E $08 $83 $3D $03 $75 $44
             $C7 $44 $1C $0A40W  $B8 $0025W  $50 $9A $187409F1RL     $83 $C4
             $02 $B8 $0064W  $50 $EB $25

#Grey death =$0FA802FFRL 5000pts
%patch $FD7F $55 $8B $EC $56 $57 $8B $76 $06 $8B $7E $08 $83 $3D $03 $75 $1D
             $C7 $44 $1C $0A5EW  $B8 $0025W  $50 $9A $187409F1RL     $83 $C4
             $02 $B8 $1388W  $50 $9A $06BD1EF2RL     $83 $C4 $02 $83 $3D $02
             $75 $05 $9A $0B8013E9RL     $5F $5E $5D $CB

#Three kinds of destroyed platform sequences: -White: $098CW
%patch $2F7FC $012CW $012CW $0003W $0000W $0000W $0004W $0000W $0000W
              $10800D44RL   $09DC1752RL   $09DC176ERL   $09AAW
%patch $2F81A $012DW $012DW $0003W $0000W $0000W $0004W $0000W $0000W
              $10800D44RL   $09DC1752RL   $09DC176ERL   $09C8W
%patch $2F838 $012EW $012EW $0003W $0000W $0000W $0004W $0000W $0000W
              $10800D44RL   $09DC1752RL   $09DC176ERL   $09E6W
%patch $2F856 $012FW $012FW $0003W $0000W $0000W $0004W $0000W $0000W
              $10800D44RL   $09DC1752RL   $09DC176ERL   $0A04W
%patch $2F874 $0130W $0130W $0003W $0000W $0000W $0004W $0000W $0000W
              $10800D44RL   $09DC1752RL   $09DC176ERL   $0A22W
%patch $2F892 $0131W $0131W $0000W $0000W $0000W $0004W $0000W $0000W
              $0FA803B4RL   $09DC1752RL   $09DC176ERL   $0000W

#Transition from d.grey to white (Stops one hit kills) =$0A40W
%patch $2F8B0 $0132W $0132W $0003W $0000W $0000W $0010W $0000W $0000W
              $10800D44RL   $09DC1752RL   $09DC176ERL   $3188W

#Light grey destroyed -Big bang =$0A5EW
%patch $2F8CE $0120W $0120W $0003W $0000W $0000W $0006W $0000W $0000W
              $10800D44RL   $09DC1752RL   $09DC176ERL   $0A7CW
%patch $2F8EC $0121W $0121W $0003W $0000W $0000W $0006W $0000W $0000W
              $10800D44RL   $09DC1752RL   $09DC176ERL   $0A9AW
%patch $2F90A $0122W $0122W $0003W $0000W $0000W $0006W $0000W $0000W #Dangerous type
              $0FA803A3RL   $09DC1752RL   $09DC176ERL   $0AB8W
%patch $2F928 $0123W $0123W $0003W $0000W $0000W $0006W $0000W $0000W
              $10800D44RL   $09DC1752RL   $09DC176ERL   $0AD6W
%patch $2F946 $0124W $0124W $0003W $0000W $0000W $0006W $0000W $0000W
              $10800D44RL   $09DC1752RL   $09DC176ERL   $0AF4W
%patch $2F964 $0125W $0125W $0003W $0000W $0000W $0006W $0000W $0000W
              $10800D44RL   $09DC1752RL   $09DC176ERL   $0B12W
%patch $2F982 $0126W $0126W $0003W $0000W $0000W $0006W $0000W $0000W
              $10800D44RL   $09DC1752RL   $09DC176ERL   $0B30W
%patch $2F9A0 $0127W $0127W $0003W $0000W $0000W $0006W $0000W $0000W
              $10800D44RL   $09DC1752RL   $09DC176ERL   $0B4EW
%patch $2F9BE $0128W $0128W $0003W $0000W $0000W $0006W $0000W $0000W
              $10800D44RL   $09DC1752RL   $09DC176ERL   $0B6CW
%patch $2F9DC $0129W $0129W $0003W $0000W $0000W $0006W $0000W $0000W
              $10800D44RL   $09DC1752RL   $09DC176ERL   $0B8AW
%patch $2F9FA $012AW $012AW $0003W $0000W $0000W $0006W $0000W $0000W
              $10800D44RL   $09DC1752RL   $09DC176ERL   $0BA8W
%patch $2FA18 $012BW $012BW $0000W $0000W $0000W $0006W $0000W $0000W
              $0FA803B4RL   $09DC1752RL   $09DC176ERL   $0000W

#Dangerous bang behavior: Change type to 3 =$0FA803A3RL
%patch $FE23 $55 $8B $EC $56 $8B $76 $06 $8B $44 $0A $C7 $04 $0003W
             $5E $5D $CB

#Revert to misc type, decrement cube variable =$0FA803B4RL
%patch $FE34 $55 $8B $EC $56 $8B $76 $06 $8B $44 $0A $C7 $04 $0001W
             $FF $0E $7A58W  $5E $5D $CB

#Hard only Platforms
%patch $EE91 $03C1W #Black
%patch $EE93 $03C1W #White
%patch $EE95 $03C1W #Grey
%patch $EE97 $03C1W #Dark grey
%patch $EE99 $03C1W #Blackx2
%patch $EE9B $03C1W #Blackx3
%patch $EE9D $03C1W #Blackx4
%patch $EE9F $03C1W #Blackx5

#Hard only Platforms initiation (Sets different offset, nocache, PERFECT CODE FIT)
%patch $ECB1 $83 $3E $7A6CW  $03 $75 $13 $8B $46 $F8 $05 $FFF9W  $50 $FF $76 
             $FC $57 $9A $10800CABRL     $83 $C4 $06 $E9 $012FW


#################################
#Items				#
#################################

#Items don't move up when got
%patch $FC5C $0000W

#Items smash on Platforms
%patch $30D70 $0FA8028CRL
%patch $30D8E $0FA8028CRL

#Smash collision: react to Platform types =$0FA8028CRL
%patch $FD0C $55 $8B $EC $56 $57 $8B $76 $06 $8B $7E $08 $83 $3D $14 $75 $11
             $C7 $44 $1C $1F46W  $B8 $002AW  $50 $9A $187409F1RL     $83 $C4
             $02 $5F $5E $5D $CB

#Change item animations so gems have individual got animations
%patch $3027C $00FAW #Red gem got
              $00E2W #Yellow gem got
              $00E2W #Blue gem got
              $0133W #Green gem got

#Change item initiation so gems don't increment item counter
%patch $ED94 $FF $06 $7A20W  $8B $46 $F8 $05 $FFC7W  $50 $FF $76 $FC $57 $9A $0FA801A3RL
             $83 $C4 $06 $8B $5E $F8 $D1 $E3 $8B $9F $4A $19 $D1 $E3 $C7 $87
             $CB3BW  $0001W  $EB $3F

#Change gem pointers to not increment
%patch $EEF5 $04A8W #Red Gem (At $ED94)
%patch $EEF7 $04A8W #Yellow Gem (At $ED94)
%patch $EEF9 $04A8W #Blue Gem (At $ED94)
%patch $EEFB $04A8W #Green Gem (At $ED94)
%patch $EF0B $04A8W #Raygun (At $ED94)

#Decrement item count on getting an item (Incs gems!)
%patch $CD7C $FF $0E $7A20W

#Ammo type item is worthless
%patch $C05B $EB $12

#Gem decrementing cancelled out
%patch $CD6B $FF $06 $7A20W
%patch $CD4E $1C

#Add point values for new item arrangement (500 for KEEN letters.)
%patch $30264 $01F4W #Red gem
              $01F4W #Yellow gem
              $01F4W #Blue gem
              $01F4W #Green gem

#Change raygun got anim
%patch $30292 $013CW

#Item got behavior: Check to see if Keen has all four gems =$0FA8034FRL -61A80
%patch $FDCF $55 $8B $EC $56 $8B $76 $06 $8B $44 $0A $83 $3E $7A60W  $00 $74
             $40 $83 $3E $7A62W  $00 $74 $39 $83 $3E $7A64W  $00 $74 $32 $83
             $3E $7A66W  $00 $74 $2B $B8 $0008W  $50 $33 $C0 $50 $B8 $7A60W
             $50 $9A $00001D25RL     $83 $C4 $06 $B8 $000CW  $50 $9A $187409F1RL
                     $83 $C4 $02 $B8 $C350W  $50 $9A $06BD1EF2RL     $83 $C4
             $02 $5E $5D $CB

#Items use new behavior when got
%patch $30DA8 $0FA8034FRL

%end